#include "tenzo.h"
#include "button.h"
#include "timer.h"
#include "efilter.h"

//clk, dt
TENZO tenzo(2, 3);
BUTTON btn(A0);
TIMER tmrRead(50);
TIMER tmrOutput(1000);
EFILTER fltr;

float f = 0;  //Нефільтроване навантаження
float F = 0;  //Фільтроване навантаження

void setup() {
  Serial.begin(9600);

  delay(1000);
  
  tenzo.tare();  //Тарування
  fltr.begin(tenzo.read()); //Починаємо роботу з фільтром
}

void loop() {
  //Кнопка натиснута
  if (btn.pressed()) {
    tenzo.tare();              //Тарування
    fltr.begin(tenzo.read());  //Починаємо новий фільтр
    tmrRead.reset();           //Перевстановлюємо таймер
  }

  //Калібрування
  if (Serial.available()) { 
    Serial.print("calib = ");  //Виводимо калібрувальний коефіцієнт
    Serial.println(tenzo.setCalib(Serial.parseFloat()));
    fltr.begin(tenzo.read());  //Починаємо новий фільтр
    tmrRead.reset();           //Перевстановлюємо таймер
  }

  //Зчитування по таймеру
  if (tmrRead.isExpired()) {
    f = tenzo.read();   //Читаємо нефільровані дані
    F = fltr.get(f);    //Фільтруємо
    tmrRead.reset();    //Перевстановлюємо таймер
  }

  //Виводимо на екран по таймеру
  if (tmrOutput.isExpired()) {
    Serial.print(f);
    Serial.print('\t');
    Serial.println(F);
    tmrOutput.reset();   //Перевстановлюємо таймер
  }
}
