#include "button.h"

BUTTON::BUTTON(byte pin) {
  _pin = pin;
  pinMode(_pin, INPUT_PULLUP);
  _state = HIGH;
  _prevTime = millis();
}

boolean BUTTON::pressed(void) {
  boolean res = false;
  unsigned long currTime = millis();

  if (!digitalRead(_pin)) {
    if (_state && ((currTime - _prevTime) > DEBOUNCE_DELAY)) {
       _prevTime = currTime;
       _state = LOW;
       res = true;
    }
  }
  else {
    if (!_state && ((currTime - _prevTime) > DEBOUNCE_DELAY)) {
      _prevTime = currTime;
      _state = HIGH; 
    }
  }  

  return res;  
}
