#ifndef TENZO_H
#define TENZO_H

#include <Arduino.h>

const byte GAIN_32 = 2;
const byte GAIN_64 = 3;
const byte GAIN_128 = 1;

const float CALIB = 558.61;

class TENZO {
  private:
    byte _clkPin;
    byte _dtPin;
    long _offset;
    byte _gain;
    float _calib;

    long readRaw(void);
  public:
    TENZO(byte clkPin, byte dtPin, byte gain = GAIN_64);

    void setGain(byte gain);
    float setCalib(float Fe);
    void tare(void);
    float read(void);
};

#endif TENZO_H
